// Code Developer Panel
// Jeffrey J Weimer
// SVN History: $Revision: 497 $ on $Date: 2008-01-31 17:13:43 -0500 (Thu, 31 Jan 2008) $

#pragma rtGlobals=1
#pragma version = 1.10

#include "ScreenSizer", version > 1.10
#pragma ModuleName=DeveloperPanel

Static Function InitializeStructure(sDP)
	STRUCT DeveloperPanelStructure &sDP

	sDP.MyPackages = CDP_Packages
end

Static STRUCTURE DeveloperPanelStructure
	string MyPackages
ENDSTRUCTURE

Function Show()

	if (strlen(WinList("DP_Panel","","WIN:64"))!=0)
		DoWindow/F DP_Panel
		return 0
	endif
	
	string cdf = GetDataFolder(1)
	NewDataFolder/O/S root:Packages
	NewDataFolder/O/S DeveloperPanel
	
	STRUCT DeveloperPanelStructure sDP
	InitializeStructure(sDP)
	
	variable nitems = ItemsInList(sDP.MyPackages), ic
	make/T/O/N=(nitems) packages
	make/O/N=(nitems) packageSEL=32
	for (ic=0;ic<nitems;ic+=1)
		packages[ic] = StringFromList(ic,sDP.MyPackages)
	endfor
	SetDataFolder $cdf
	
	ScreenSizer#Initialize(0)
	
	variable pw = 240, ph = 160, lw = 200, lh = 100

	ScreenSizer#MakePanel(-95,0,pw,ph,"Developer Panel",other="/K=1/N=DP_Panel")
	ModifyPanel fixedSize=1, noEdit=1
	
	// package list
	ListBox list0 mode=0,font="default", listwave=packages, selwave=packageSEL
	ListBox list0 pos={5,10},size={lw,lh},frame=0,font="default", proc=TogglePackage
	// insert with/without compile
	CheckBox check0,pos={5,lh+20},size={165,15},title="Compile After Insert"
	CheckBox check0,value= 1
	// independent module development
	CheckBox check1,pos={5,lh+40},size={165,15},title="Indepent Module Development"
	CheckBox check1,value= 0,proc=SetIMDevelopment
	string exeStr
	sprintf exeStr, "SetIgorOption IndependentModuleDev = %g", 0
	Execute exeStr			
	return 0
end

Function SetIMDevelopment(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	string exeStr = ""
	switch( cba.eventCode )
		case 2:
			sprintf exeStr, "SetIgorOption IndependentModuleDev = %g", cba.checked
			Execute exeStr			
			break
	endswitch

	return 0
End

Function TogglePackage(lba) : ListBoxControl
	STRUCT WMListboxAction &lba

	Variable row = lba.row
	WAVE/T/Z listWave = lba.listWave
	WAVE/Z selWave = lba.selWave

	switch( lba.eventCode )
		case 2:
			variable nitems = numpnts(listWave) - 1
			if (row>nitems)
				break
			endif
//			print "mouseup here", row, nitems, listWave[row], selWave[row]

			LoadUnloadPackage(listWave[row], selWave[row])
			break
	endswitch

	return 0
End

Function LoadUnloadPackage(itsName,itsValue)
	string itsName
	variable itsValue
	
	string exeCmd=""
	if (itsValue == 32)
//		print "unloading"
		exeCmd = "DELETEINCLUDE \"" + itsName +"\""
	else
//		print "loading"
		exeCmd = "INSERTINCLUDE \"" + itsName +"\""
	endif
	Execute/P/Q/Z exeCmd
	ControlInfo check0
	if (V_Value || (itsValue ==32))
		Execute/P/Q/Z "COMPILEPROCEDURES"
	endif
	return 0
	
end
